package org.serverct.Other.Item;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.plugin.Plugin;
import org.serverct.Other.Item.VariableManager;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.CopyOnWriteArrayList;

public class Timer {
    @SuppressWarnings("unchecked")
	private CopyOnWriteArrayList<Location> location = VariableManager.getlocation();
    @SuppressWarnings("unchecked")
	private HashMap<Location,Material> lt_mr = VariableManager.getlt_mr();
    @SuppressWarnings("unchecked")
	private ArrayList<String> blocklist = VariableManager.getblocklist();
    @SuppressWarnings("unchecked")
	private HashMap<Location,Long> lt_time = VariableManager.getlt_time();

    public void run() {
        Bukkit.getScheduler().runTaskTimer(getInstance(),()->{
            Long nowTime = System.currentTimeMillis()/1000;
            for (Location lt : location) {
                boolean skip = true;//是否跳过坐标
                Material material = null;//此刻坐标的材?

                if (lt_mr.get(lt) != null) {
                    material = lt_mr.get(lt);//获取此刻坐标的材?
                }
                for (String block : blocklist) {//判断此时位置的材质是否在列表?
                    if (material == Material.getMaterial(block)) {
                        skip = false;
                    }
                }
                if (skip) continue;//如果不在列表?,跳过此处坐标
                int time = getInstance().getConfig().getInt("blocks." + material + ".restoretime");
                System.out.println("blocks." + material + ".restoretime: " + time);
                Material replace = Material.getMaterial(getInstance().getConfig().getString("blocks." + material + ".replaceblock"));
                if (lt_time.get(lt) != null) {
                    if (nowTime - lt_time.get(lt) + 1 >= time) {//时间大于预设时间
                        //System.out.println("时间大于delay");
                        if (getInstance().getConfig().getBoolean("blocks." + material + ".replace")) {//如果replacerestore??
                            if (lt.getBlock().getType() == Material.AIR) {//如果等于空气,恢复成替换方?
                                //System.out.println("如果等于空气,恢复成替换方?");
                                lt.getBlock().setType(replace);
                                lt_time.put(lt,System.currentTimeMillis()/1000);
                            } else if (lt.getBlock().getType() == replace) {//如果等于替换方块,恢复成原始方?
                                //System.out.println("如果等于替换方块,恢复成原始方?");
                                lt.getBlock().setType(lt_mr.get(lt));
                                lt_time.remove(lt);
                                lt_mr.remove(lt);
                                location.remove(lt);
                            }
                        } else  {//如果replacerestore关闭
                            if (lt.getBlock().getType() == Material.AIR) {//如果等于空气,恢复成原始方?
                                lt.getBlock().setType(lt_mr.get(lt));
                                lt_time.remove(lt);
                                lt_mr.remove(lt);
                                location.remove(lt);
                            }
                        }
                    }
                }
            }
        },0L,20L);//循环1秒执行检?
    }

	private Plugin getInstance() {
		// TODO Զɵķ
		return null;
	}
}
